<?php
// version 1.01 - Ken True - replace eregi with preg_match for PHP 5.6+

// get files content
$file_clientraw = file_get_contents("./clientraw.txt");
$file_clientrawextra = file_get_contents("./clientrawextra.txt");
$file_clientrawdaily = file_get_contents("./clientrawdaily.txt");
$file_clientrawhour = file_get_contents("./clientrawhour.txt");

/*
$file_clientraw = file_get_contents("http://meteo.valentinois.net/wdl/clientraw.txt");
$file_clientrawextra = file_get_contents("http://meteo.valentinois.net/wdl/clientrawextra.txt");
$file_clientrawdaily = file_get_contents("http://meteo.valentinois.net/wdl/clientrawdaily.txt");
$file_clientrawhour = file_get_contents("http://meteo.valentinois.net/wdl/clientrawhour.txt");
*/

// put the data into arrays
$data_clientraw = explode(" ", $file_clientraw);
$data_clientrawextra = explode(" ", $file_clientrawextra);
$data_clientrawdaily = explode(" ", $file_clientrawdaily);
$data_clientrawhour = explode(" ", $file_clientrawhour);

/***** clientraw ******/

$clientraw_cpt = 0;
$clientraw_max = count( $data_clientraw ); //count all values in the array
$clientraw_content = "";
//display clientraw content
while( $clientraw_cpt < $clientraw_max-1 )
{
  if ($types_clientraw[$clientraw_cpt] == "Icon" || $types_clientraw[$clientraw_cpt] == "Icne") //test current data type
	  {//in case of Icon type, display the value + the description. ex: 4 (Cloudy)
	  $data_clientraw[$clientraw_cpt] = $data_clientraw[$clientraw_cpt]." (".$icons[$data_clientraw[$clientraw_cpt]].")";
	  }

//display units - depends on $types_clientraw value
	if (preg_match('!Celsius!i', $types_clientraw[$clientraw_cpt]))
		{$data_clientraw[$clientraw_cpt] = $data_clientraw[$clientraw_cpt]. "C = ".sprintf("%01.1f", CtoF($data_clientraw[$clientraw_cpt]))."F";}
	if (preg_match('!Millimeters!i', $types_clientraw[$clientraw_cpt]) || preg_match('!Millimtres!i', $types_clientraw[$clientraw_cpt]))
		{$data_clientraw[$clientraw_cpt] = $data_clientraw[$clientraw_cpt]. " mm = ".sprintf(MMtoINCHES($data_clientraw[$clientraw_cpt]))." in";}
	if (preg_match('!hPA!i', $types_clientraw[$clientraw_cpt]))
		{$data_clientraw[$clientraw_cpt] = $data_clientraw[$clientraw_cpt]. " hPa = ".sprintf(HPAtoINHG($data_clientraw[$clientraw_cpt]))." inHg";}
	if (preg_match('!Knots!i', $types_clientraw[$clientraw_cpt]) || preg_match('!Noeud!i', $types_clientraw[$clientraw_cpt]))
		{$data_clientraw[$clientraw_cpt] = $data_clientraw[$clientraw_cpt]. " kts = ".sprintf(KTStoMPH($data_clientraw[$clientraw_cpt]))." mph = ".sprintf(KTStoKMH($data_clientraw[$clientraw_cpt]))." km/h = ".sprintf(KTStoMS($data_clientraw[$clientraw_cpt]))." m/s";}
	if (preg_match('!Compass!i', $types_clientraw[$clientraw_cpt]) || preg_match('!Boussole!i', $types_clientraw[$clientraw_cpt]))
		{$data_clientraw[$clientraw_cpt] = $data_clientraw[$clientraw_cpt]. " (".$wind_direction[(DEGREEStoCOMPASS($data_clientraw[$clientraw_cpt]))].")";}
	if (preg_match('!Percent!i', $types_clientraw[$clientraw_cpt]) || preg_match('!Pourcent!i', $types_clientraw[$clientraw_cpt]))
		{$data_clientraw[$clientraw_cpt] = $data_clientraw[$clientraw_cpt]. " %";}
	if (preg_match('!Feet!i', $types_clientraw[$clientraw_cpt]) || preg_match('!Pieds!i', $types_clientraw[$clientraw_cpt]))
		{$data_clientraw[$clientraw_cpt] = $data_clientraw[$clientraw_cpt]. " ft = ".sprintf(FTtoM($data_clientraw[$clientraw_cpt]))." m";}

  $clientraw_content .= "<tr><td>".$clientraw_cpt."</td><td>".$labels_clientraw[$clientraw_cpt]."</td><td>".$types_clientraw[$clientraw_cpt]."</td><td>".$data_clientraw[$clientraw_cpt]."</td></tr>\n";
  $clientraw_cpt++;
}

/***** clientrawextra ******/

$clientrawextra_cpt = 0;
$clientrawextra_max = count( $data_clientrawextra );
$clientrawextra_content = "";

//display clientrawextra content
while( $clientrawextra_cpt < $clientrawextra_max-1 )
{
   //test current field number
  if ($clientrawextra_cpt == "484" || $clientrawextra_cpt == "485" || $clientrawextra_cpt == "486" || $clientrawextra_cpt == "487" || $clientrawextra_cpt == "488" || $clientrawextra_cpt == "489" || $clientrawextra_cpt == "490")
	  {//in case of Rain by day (#484 to #490), divide the rain value by 10
	  $data_clientrawextra[$clientrawextra_cpt] = ($data_clientrawextra[$clientrawextra_cpt]/10);
	  }

  //for the forecast field, change uppercase to lowercase and replace _ by spaces
  if ($clientrawextra_cpt == "531")
	  {
	  $data_clientrawextra[$clientrawextra_cpt] = ucfirst(strtolower(preg_replace('/_/', ' ' , $data_clientrawextra[$clientrawextra_cpt])));
	  }

//display units - depends on $types_clientrawextraextra value
	if (preg_match('!Celsius!i', $types_clientrawextra[$clientrawextra_cpt]))
		{$data_clientrawextra[$clientrawextra_cpt] = $data_clientrawextra[$clientrawextra_cpt]. "C = ".sprintf("%01.1f", CtoF($data_clientrawextra[$clientrawextra_cpt]))."F";}
	if (preg_match('!Millimeters!i', $types_clientrawextra[$clientrawextra_cpt]) || preg_match('!Millimtres!i', $types_clientrawextra[$clientrawextra_cpt]))
		{$data_clientrawextra[$clientrawextra_cpt] = $data_clientrawextra[$clientrawextra_cpt]. " mm = ".sprintf(MMtoINCHES($data_clientrawextra[$clientrawextra_cpt]))." in";}
	if (preg_match('!hPA!i', $types_clientrawextra[$clientrawextra_cpt]))
		{$data_clientrawextra[$clientrawextra_cpt] = $data_clientrawextra[$clientrawextra_cpt]. " hPa = ".sprintf(HPAtoINHG($data_clientrawextra[$clientrawextra_cpt]))." inHg";}
	if (preg_match('!Knots!i', $types_clientrawextra[$clientrawextra_cpt]) || preg_match('!Noeud!i', $types_clientrawextra[$clientrawextra_cpt]))
		{$data_clientrawextra[$clientrawextra_cpt] = $data_clientrawextra[$clientrawextra_cpt]. " kts = ".sprintf(KTStoMPH($data_clientrawextra[$clientrawextra_cpt]))." mph = ".sprintf(KTStoKMH($data_clientrawextra[$clientrawextra_cpt]))." km/h = ".sprintf(KTStoMS($data_clientrawextra[$clientrawextra_cpt]))." m/s";}
	if (preg_match('!Compass!i', $types_clientrawextra[$clientrawextra_cpt]) || preg_match('!Boussole!i', $types_clientrawextra[$clientrawextra_cpt]))
		{$data_clientrawextra[$clientrawextra_cpt] = $data_clientrawextra[$clientrawextra_cpt]. " (".$wind_direction[(DEGREEStoCOMPASS($data_clientrawextra[$clientrawextra_cpt]))].")";}
	if (preg_match('!Percent!i', $types_clientrawextra[$clientrawextra_cpt]) || preg_match('!Pourcent!i', $types_clientrawextra[$clientrawextra_cpt]))
		{$data_clientrawextra[$clientrawextra_cpt] = $data_clientrawextra[$clientrawextra_cpt]. " %";}
	if (preg_match('!Feet!i', $types_clientrawextra[$clientrawextra_cpt]) || preg_match('!Pieds!i', $types_clientrawextra[$clientrawextra_cpt]))
		{$data_clientrawextra[$clientrawextra_cpt] = $data_clientrawextra[$clientrawextra_cpt]. " ft = ".sprintf(FTtoM($data_clientrawextra[$clientrawextra_cpt]))." m";}

  $clientrawextra_content .= "<tr><td>".$clientrawextra_cpt."</td><td>".$labels_clientrawextra[$clientrawextra_cpt]."</td><td>".$types_clientrawextra[$clientrawextra_cpt]."</td><td>".$data_clientrawextra[$clientrawextra_cpt]."</td></tr>\n";
  $clientrawextra_cpt++;
}

/***** clientrawdaily ******/

$clientrawdaily_cpt = 0;
$clientrawdaily_max = count( $data_clientrawdaily );
$clientrawdaily_content = "";

//display clientrawdaily content
while( $clientrawdaily_cpt < $clientrawdaily_max-1 )
{
//display units - depends on $types_clientrawdaily value
	if (preg_match('!Celsius!i', $types_clientrawdaily[$clientrawdaily_cpt]))
		{$data_clientrawdaily[$clientrawdaily_cpt] = $data_clientrawdaily[$clientrawdaily_cpt]. "C = ".sprintf("%01.1f", CtoF($data_clientrawdaily[$clientrawdaily_cpt]))."F";}
	if (preg_match('!Millimeters!i', $types_clientrawdaily[$clientrawdaily_cpt]) || preg_match('!Millimtres!i', $types_clientrawdaily[$clientrawdaily_cpt]))
		{$data_clientrawdaily[$clientrawdaily_cpt] = $data_clientrawdaily[$clientrawdaily_cpt]. " mm = ".sprintf(MMtoINCHES($data_clientrawdaily[$clientrawdaily_cpt]))." in";}
	if (preg_match('!hPA!i', $types_clientrawdaily[$clientrawdaily_cpt]))
		{$data_clientrawdaily[$clientrawdaily_cpt] = $data_clientrawdaily[$clientrawdaily_cpt]. " hPa = ".sprintf(HPAtoINHG($data_clientrawdaily[$clientrawdaily_cpt]))." inHg";}
	if (preg_match('!Knots!i', $types_clientrawdaily[$clientrawdaily_cpt]) || preg_match('!Noeud!i', $types_clientrawdaily[$clientrawdaily_cpt]))
		{$data_clientrawdaily[$clientrawdaily_cpt] = $data_clientrawdaily[$clientrawdaily_cpt]. " kts = ".sprintf(KTStoMPH($data_clientrawdaily[$clientrawdaily_cpt]))." mph = ".sprintf(KTStoKMH($data_clientrawdaily[$clientrawdaily_cpt]))." km/h = ".sprintf(KTStoMS($data_clientrawdaily[$clientrawdaily_cpt]))." m/s";}
	if (preg_match('!Compass!i', $types_clientrawdaily[$clientrawdaily_cpt]) || preg_match('!Boussole!i', $types_clientrawdaily[$clientrawdaily_cpt]))
		{$data_clientrawdaily[$clientrawdaily_cpt] = $data_clientrawdaily[$clientrawdaily_cpt]. " (".$wind_direction[(DEGREEStoCOMPASS($data_clientrawdaily[$clientrawdaily_cpt]))].")";}
	if (preg_match('!Percent!i', $types_clientrawdaily[$clientrawdaily_cpt]) || preg_match('!Pourcent!i', $types_clientrawdaily[$clientrawdaily_cpt]))
		{$data_clientrawdaily[$clientrawdaily_cpt] = $data_clientrawdaily[$clientrawdaily_cpt]. " %";}
	if (preg_match('!Feet!i', $types_clientrawdaily[$clientrawdaily_cpt]) || preg_match('!Pieds!i', $types_clientrawdaily[$clientrawdaily_cpt]))
		{$data_clientrawdaily[$clientrawdaily_cpt] = $data_clientrawdaily[$clientrawdaily_cpt]. " ft = ".sprintf(FTtoM($data_clientrawdaily[$clientrawdaily_cpt]))." m";}

  $clientrawdaily_content .= "<tr><td>".$clientrawdaily_cpt."</td><td>".$labels_clientrawdaily[$clientrawdaily_cpt]."</td><td>".$types_clientrawdaily[$clientrawdaily_cpt]."</td><td>".$data_clientrawdaily[$clientrawdaily_cpt]."</td></tr>\n";
  $clientrawdaily_cpt++;
}

/***** clientrawhour ******/

$clientrawhour_cpt = 0;
$clientrawhour_max = count( $data_clientrawhour );
$clientrawhour_content = "";

//display clientrawhour content
while( $clientrawhour_cpt < $clientrawhour_max-1 )
{
//display units - depends on $types_clientrawhour value
	if (preg_match('!Celsius!i', $types_clientrawhour[$clientrawhour_cpt]))
		{$data_clientrawhour[$clientrawhour_cpt] = $data_clientrawhour[$clientrawhour_cpt]. "C = ".sprintf("%01.1f", CtoF($data_clientrawhour[$clientrawhour_cpt]))."F";}
	if (preg_match('!Millimeters!i', $types_clientrawhour[$clientrawhour_cpt]) || preg_match('!Millimtres!i', $types_clientrawhour[$clientrawhour_cpt]))
		{$data_clientrawhour[$clientrawhour_cpt] = $data_clientrawhour[$clientrawhour_cpt]. " mm = ".sprintf(MMtoINCHES($data_clientrawhour[$clientrawhour_cpt]))." in";}
	if (preg_match('!hPA!i', $types_clientrawhour[$clientrawhour_cpt]))
		{$data_clientrawhour[$clientrawhour_cpt] = $data_clientrawhour[$clientrawhour_cpt]. " hPa = ".sprintf(HPAtoINHG($data_clientrawhour[$clientrawhour_cpt]))." inHg";}
	if (preg_match('!Knots!i', $types_clientrawhour[$clientrawhour_cpt]) || preg_match('!Noeud!i', $types_clientrawhour[$clientrawhour_cpt]))
		{$data_clientrawhour[$clientrawhour_cpt] = $data_clientrawhour[$clientrawhour_cpt]. " kts = ".sprintf(KTStoMPH($data_clientrawhour[$clientrawhour_cpt]))." mph = ".sprintf(KTStoKMH($data_clientrawhour[$clientrawhour_cpt]))." km/h = ".sprintf(KTStoMS($data_clientrawhour[$clientrawhour_cpt]))." m/s";}
	if (preg_match('!Compass!i', $types_clientrawhour[$clientrawhour_cpt]) || preg_match('!Boussole!i', $types_clientrawhour[$clientrawhour_cpt]))
		{$data_clientrawhour[$clientrawhour_cpt] = $data_clientrawhour[$clientrawhour_cpt]. " (".$wind_direction[(DEGREEStoCOMPASS($data_clientrawhour[$clientrawhour_cpt]))].")";}
	if (preg_match('!Percent!i', $types_clientrawhour[$clientrawhour_cpt]) || preg_match('!Pourcent!i', $types_clientrawhour[$clientrawhour_cpt]))
		{$data_clientrawhour[$clientrawhour_cpt] = $data_clientrawhour[$clientrawhour_cpt]. " %";}
	if (preg_match('!Feet!i', $types_clientrawhour[$clientrawhour_cpt]) || preg_match('!Pieds!i', $types_clientrawhour[$clientrawhour_cpt]))
		{$data_clientrawhour[$clientrawhour_cpt] = $data_clientrawhour[$clientrawhour_cpt]. " ft = ".sprintf(FTtoM($data_clientrawhour[$clientrawhour_cpt]))." m";}

  $clientrawhour_content .= "<tr><td>".$clientrawhour_cpt."</td><td>".$labels_clientrawhour[$clientrawhour_cpt]."</td><td>".$types_clientrawhour[$clientrawhour_cpt]."</td><td>".$data_clientrawhour[$clientrawhour_cpt]."</td></tr>\n";
  $clientrawhour_cpt++;
}

/************ Function Definitions *************/

// CtoF: converts degrees Celcius to degrees Fahrenheit
function CtoF($value) {
  return round($value = ((1.8* $value) + 32),2);
} // end function C_to_F

// KTStoMPH: converts knots to MPH
function KTStoMPH($value) {
  return round($value = (1.15155 * $value),2);
} // end function KTStoMPH

// KTStoMPH: converts knots to km/h
function KTStoKMH($value) {
  return round($value = (1.85325 * $value),2);
} // end function KTStoKMH

// KTStoMPH: converts knots to m/s
function KTStoMS($value) {
  return round($value = (0.514791 * $value),2);
} // end function KTStoMS

// MMtoINCHES: converts mm to inches
function MMtoINCHES($value) {
  return round($value = (0.0393700787 * $value),2);
} // end function MMtoINCHES
 
// HPAtoINHg: converts hPa to inHg
function HPAtoINHG($value) {
  return round($value = (0.295300 * $value)/10,2);
} // end function HPAtoINHG

// FTtoM: converts Feet to Meters
function FTtoM($value) {
  return round($value = ($value/3.28084),2);
} // end function FTtoM

// DEGREEStoCOMPASS: converts  to direction
function DEGREEStoCOMPASS($value) {
	if ($value >= 0 && $value <= 11.25){$value = '0';}
	if ($value > 348.75 && $value <= 360){$value = '1';}
	if ($value > 11.25 && $value <= 33.75){$value = '2';}
	if ($value > 33.75 && $value <= 56.25){$value = '3';}
	if ($value > 56.25 && $value <= 78.75){$value = '4';}
	if ($value > 78.75 && $value <= 101.25){$value = '5';}
	if ($value > 101.25 && $value <= 123.75){$value = '6';}
	if ($value > 123.75 && $value <= 146.25){$value = '7';}
	if ($value > 146.25 && $value <= 168.75){$value = '8';}
	if ($value > 168.75 && $value <= 191.25){$value = '9';}
	if ($value > 191.25 && $value <= 213.75){$value = '10';}
	if ($value > 213.75 && $value <= 236.25){$value = '11';}
	if ($value > 236.25 && $value <= 258.75){$value = '12';}
	if ($value > 258.75 && $value <= 281.25){$value = '13';}
	if ($value > 281.25 && $value <= 303.75){$value = '14';}
	if ($value > 303.75 && $value <= 326.25){$value = '15';}
	if ($value > 326.25 && $value <= 348.75){$value = '16';}
  return $value;
} // end function DEGREEStoCOMPASS

/************* End of Function Definitions ****************/

?>